/**
 * docobserver.js, 2016
 * @author ED
 */

/**
 * @namespace antvd
 */
var antvd = (function(antvd)
{
    if (!antvd.AntLib)
    {
        antvd.AntLib = AntLib;
    }

    /**
     * @class DocumentObserver
     */
    function DocumentObserver()
    {
        const Ci = Components.interfaces;
        const Cc = Components.classes;

        var windowsService = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);

        /**
         * The function called by firefox, entry point of this class
         * @param subject       The object containing the request params
         * @param topic         The specific event that trigger the function
         * @param data          the request data (seems to be empty)
         */
        this.observe = function(subject, topic, data)
        {
            let notified = false;
            
            try
            {
                if (AntPrefs)
                {
                    notified = AntPrefs.getAntBranch().getBoolPref('facebook.autoplay.notified');
                }
            }
            catch(e)
            {                
            }
            
            if (notified == true)
            {
                return true;
            }
            
            try
            {
                var currentWindow = windowsService.getMostRecentWindow('navigator:browser');
                var browser = currentWindow.getBrowser();
                var uri = browser.currentURI;
                var url = uri.spec;
                
                if (url && url.length > 0)
                {
                    if (url.indexOf("www.facebook.com") != -1)
                    {
                        Task.spawn(function* () {
                            
                        Components.classes['@mozilla.org/alerts-service;1']
                            .getService(Components.interfaces.nsIAlertsService)
                            .showAlertNotification(
                                'chrome://antbar/skin/icon48.png',
                                "Ant Video downloader",
                                antvd.AntLang.getString("AntBar.FacebookAutoplayNotification")
                            );
                            
                            return true;
                            
                        }).then(function(result) {

                            try
                            {
                                if (AntPrefs)
                                {
                                    AntPrefs.getAntBranch().setBoolPref('facebook.autoplay.notified', 1);
                                    
                                    antvd.AntLib.toLog("Set preference facebook.autoplay.notified = 1");
                                }
                            }
                            catch(e)
                            {                
                                antvd.AntLib.logError(
                                    "Error while setting preference facebook.autoplay.notified",
                                    "DocumentObserver.observe (docobserver.js)",
                                    e
                                )
                            }
                        },
                        function(exception){});
                    }
                }
            }
            catch(e)
            {
                antvd.AntLib.logError(
                    "Failed to obtain current URL",
                    "DocumentObserver.observe (docobserver.js)",
                    e
                )
            }
        };
    };

    antvd.DocumentObserver = DocumentObserver;
    
    return antvd;

})(antvd);
